SELECT
        month AS `日期`
        ,device_os_type AS `系统`
        ,active_type AS `活跃`
        ,channel as `渠道`
        ,dau AS `dau`
        ,ai_report_uv AS `ai结果页uv`
        ,ai_report_card_click_uv AS `ai结果页内容卡片点击uv`
        ,ai_report_card_click_pv AS `ai结果页内容卡片点击pv`
        ,ai_report_good_click AS `来源于ai结果页的good click`
        ,CONCAT(ROUND(ai_report_card_click_uv/ai_report_uv*100,2),'%') AS `ai结果页内容卡片点击uv/ai结果页uv`
        ,CONCAT(ROUND(ai_report_card_click_pv/ai_report_uv*100,2),'%') AS `ai结果页内容卡片点击pv/ai结果页uv`
        ,CONCAT(ROUND(ai_report_good_click/ai_report_uv*100,2),'%') AS `来源于ai结果页的good click/ai结果页uv`
FROM
(
    select substr(day_id,1,6) as month
            ,device_os_type
            ,active_type
            ,channel
            ,round(avg(dau),0) as dau
            ,round(avg(ai_report_uv),0) as ai_report_uv
            ,round(avg(ai_report_card_click_uv),0) as ai_report_card_click_uv
            ,round(avg(ai_report_card_click_pv),0) as ai_report_card_click_pv
            ,round(avg(ai_report_good_click),0) as ai_report_good_click
    FROM pm.tl_pm_content_v2
    where partition_day>='20201018' and partition_day <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
    group by substr(day_id,1,6),device_os_type,active_type,channel
)t1
order by `日期`,`系统`,`活跃`,`渠道`