SELECT
        month AS `日期`
        ,device_os_type AS `系统`
        ,active_type AS `活跃`
        ,channel as `渠道`
        ,dau AS `DAU`
        ,retention_rate_2 AS `次留率(%)`
        ,retention_rate_3 AS `第3日留存率(%)`
        ,retention_rate_7 AS `第7日留存率(%)`
        ,home_card_click_uv AS `首页卡片点击uv`
        ,home_card_click_pv AS `首页卡片点击pv`
        ,home_good_click AS `来源于首页的good click`
        ,CONCAT(ROUND(home_card_click_uv/dau*100,2),'%') AS `首页卡片点击uv/DAU`
        ,CONCAT(ROUND(home_card_click_pv/dau*100,2),'%') AS `首页卡片点击pv/DAU`
        ,CONCAT(ROUND(home_good_click/dau*100,2),'%') AS `来源于首页的good click/DAU`
        ,page_stay_per_device AS `单设备内容浏览时长(m)`
FROM
(
    select substr(day_id,1,6) as month
            ,device_os_type
            ,active_type
            ,channel
            ,round(avg(dau),0) as dau
            ,round(avg(if(retention_rate_2=0,NULL,retention_rate_2)),2) as retention_rate_2
            ,round(avg(if(retention_rate_3=0,NULL,retention_rate_3)),2) as retention_rate_3
            ,round(avg(if(retention_rate_7=0,NULL,retention_rate_7)),2) as retention_rate_7
            ,round(avg(home_card_click_uv),0) as home_card_click_uv
            ,round(avg(home_card_click_pv),0) as home_card_click_pv
            ,round(avg(home_good_click),0) as home_good_click
            ,round(avg(page_stay_per_device),2) as page_stay_per_device
    FROM pm.tl_pm_content_v2
    where partition_day>='20201018' and partition_day <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
    group by substr(day_id,1,6),device_os_type,active_type,channel
)t1
order by `日期`,`系统`,`活跃`,`渠道`