SELECT
        day_id AS `日期`
        ,device_os_type AS `系统`
        ,active_type AS `活跃`
        ,channel as `渠道`
        ,dau AS `DAU`
        ,retention_rate_2 AS `次留率(%)`
        ,retention_rate_3 AS `第3日留存率(%)`
        ,retention_rate_7 AS `第7日留存率(%)`
        ,home_card_click_uv AS `首页卡片点击uv`
        ,home_card_click_pv AS `首页卡片点击pv`
        ,home_good_click AS `来源于首页的good click`
        ,NVL(CONCAT(ROUND(home_card_click_uv/dau*100,2),'%'),0) AS `首页卡片点击uv/DAU`
        ,NVL(CONCAT(ROUND(home_card_click_pv/dau*100,2),'%'),0) AS `首页卡片点击pv/DAU`
        ,NVL(CONCAT(ROUND(home_good_click/dau*100,2),'%'),0) AS `来源于首页的good click/DAU`
        ,NVL(page_stay_per_device,0) AS `单设备内容浏览时长(m)`
FROM pm.tl_pm_content_v2
where partition_day>='20201018' and partition_day <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
order by `日期`,`系统`,`活跃`,`渠道`