--***************************************************************
--*脚本名称:
--*功能: push日报
--*业务名称: pm
--*输入数据:
--*作者: weiyimin@igengmei.com
--*更新时间:
--***************************************************************

--设置全局变量&UDF
SET mapreduce.job.queuename=data;

--使用bl数据库
USE pm;

--创建BL层内部表
CREATE TABLE IF NOT EXISTS pm.tl_pm_push_d
(
 day_id string comment '{"chs_name":"当天日期","description":"","etl":"","value":"","remark":""}',
 device_os_type string comment '{"chs_name":"设备类型","description":"","etl":"","value":"","remark":""}',
 active_type string comment '{"chs_name":"活跃类型","description":"","etl":"","value":"","remark":""}',
 dau BIGINT comment '{"chs_name":"DAU","description":"","etl":"","value":"","remark":""}',
 is_open_uv BIGINT comment '{"chs_name":"push开启设备数","description":"","etl":"","value":"","remark":""}',
 push_receive_uv BIGINT comment '{"chs_name":"push接收设备数","description":"","etl":"","value":"","remark":""}',
 push_receive_pv BIGINT comment '{"chs_name":"push接收人次","description":"","etl":"","value":"","remark":""}',
 push_open_uv BIGINT comment '{"chs_name":"push拉起设备数","description":"","etl":"","value":"","remark":""}',
 push_open_pv BIGINT comment '{"chs_name":"push拉起人次","description":"","etl":"","value":"","remark":""}',
 push_open_2_uv BIGINT comment '{"chs_name":"push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 push_open_2_pv BIGINT comment '{"chs_name":"push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 op_receive_uv BIGINT comment '{"chs_name":"运营push接收设备数","description":"","etl":"","value":"","remark":""}',
 op_receive_pv BIGINT comment '{"chs_name":"运营push接收人次","description":"","etl":"","value":"","remark":""}',
 op_push_open_uv BIGINT comment '{"chs_name":"运营push拉起设备数","description":"","etl":"","value":"","remark":""}',
 op_push_open_pv BIGINT comment '{"chs_name":"运营push拉起人次","description":"","etl":"","value":"","remark":""}',
 op_push_open_2_uv BIGINT comment '{"chs_name":"运营push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 op_push_open_2_pv BIGINT comment '{"chs_name":"运营push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 xitong_receive_uv BIGINT comment '{"chs_name":"除运营、个性化、签到、意愿外push接收设备数","description":"","etl":"","value":"","remark":""}',
 xitong_receive_pv BIGINT comment '{"chs_name":"除运营、个性化、签到、意愿外push接收人次","description":"","etl":"","value":"","remark":""}',
 xitong_push_open_uv BIGINT comment '{"chs_name":"除运营、个性化、签到、意愿外push拉起设备数","description":"","etl":"","value":"","remark":""}',
 xitong_push_open_pv BIGINT comment '{"chs_name":"除运营、个性化、签到、意愿外push拉起人次","description":"","etl":"","value":"","remark":""}',
 xitong_push_open_2_uv BIGINT comment '{"chs_name":"除运营、个性化、签到、意愿外push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 xitong_push_open_2_pv BIGINT comment '{"chs_name":"除运营、个性化、签到、意愿外push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 will_receive_uv BIGINT comment '{"chs_name":"意愿探索push接收设备数","description":"","etl":"","value":"","remark":""}',
 will_receive_pv BIGINT comment '{"chs_name":"意愿探索push接收人次","description":"","etl":"","value":"","remark":""}',
 will_push_open_uv BIGINT comment '{"chs_name":"意愿探索push拉起设备数","description":"","etl":"","value":"","remark":""}',
 will_push_open_pv BIGINT comment '{"chs_name":"意愿探索push拉起人次","description":"","etl":"","value":"","remark":""}',
 will_push_open_2_uv BIGINT comment '{"chs_name":"意愿探索push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 will_push_open_2_pv BIGINT comment '{"chs_name":"意愿探索push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 sign_receive_uv BIGINT comment '{"chs_name":"签到push接收设备数","description":"","etl":"","value":"","remark":""}',
 sign_receive_pv BIGINT comment '{"chs_name":"签到push接收人次","description":"","etl":"","value":"","remark":""}',
 sign_push_open_uv BIGINT comment '{"chs_name":"签到push拉起设备数","description":"","etl":"","value":"","remark":""}',
 sign_push_open_pv BIGINT comment '{"chs_name":"签到push拉起人次","description":"","etl":"","value":"","remark":""}',
 sign_push_open_2_uv BIGINT comment '{"chs_name":"签到push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 sign_push_open_2_pv BIGINT comment '{"chs_name":"签到push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 personal_receive_uv BIGINT comment '{"chs_name":"个性化push接收设备数","description":"","etl":"","value":"","remark":""}',
 personal_receive_pv BIGINT comment '{"chs_name":"个性化push接收人次","description":"","etl":"","value":"","remark":""}',
 personal_push_open_uv BIGINT comment '{"chs_name":"个性化push拉起设备数","description":"","etl":"","value":"","remark":""}',
 personal_push_open_pv BIGINT comment '{"chs_name":"个性化push拉起人次","description":"","etl":"","value":"","remark":""}',
 personal_push_open_2_uv BIGINT comment '{"chs_name":"个性化push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 personal_push_open_2_pv BIGINT comment '{"chs_name":"个性化push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 ctr_receive_uv BIGINT comment '{"chs_name":"ctr_push接收设备数","description":"","etl":"","value":"","remark":""}',
 ctr_receive_pv BIGINT comment '{"chs_name":"ctr_push接收人次","description":"","etl":"","value":"","remark":""}',
 ctr_push_open_uv BIGINT comment '{"chs_name":"ctr_push拉起设备数","description":"","etl":"","value":"","remark":""}',
 ctr_push_open_pv BIGINT comment '{"chs_name":"ctr_push拉起人次","description":"","etl":"","value":"","remark":""}',
 ctr_push_open_2_uv BIGINT comment '{"chs_name":"ctr_push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 ctr_push_open_2_pv BIGINT comment '{"chs_name":"ctr_push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 non_ctr_receive_uv BIGINT comment '{"chs_name":"非ctr_push接收设备数","description":"","etl":"","value":"","remark":""}',
 non_ctr_receive_pv BIGINT comment '{"chs_name":"非ctr_push接收人次","description":"","etl":"","value":"","remark":""}',
 non_ctr_push_open_uv BIGINT comment '{"chs_name":"非ctr_push拉起设备数","description":"","etl":"","value":"","remark":""}',
 non_ctr_push_open_pv BIGINT comment '{"chs_name":"非ctr_push拉起人次","description":"","etl":"","value":"","remark":""}',
 non_ctr_push_open_2_uv BIGINT comment '{"chs_name":"非ctr_push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 non_ctr_push_open_2_pv BIGINT comment '{"chs_name":"非ctr_push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 AI_receive_uv BIGINT comment '{"chs_name":"AI_push接收设备数","description":"","etl":"","value":"","remark":""}',
 AI_receive_pv BIGINT comment '{"chs_name":"AI_push接收人次","description":"","etl":"","value":"","remark":""}',
 AI_push_open_uv BIGINT comment '{"chs_name":"AI_push拉起设备数","description":"","etl":"","value":"","remark":""}',
 AI_push_open_pv BIGINT comment '{"chs_name":"AI_push拉起人次","description":"","etl":"","value":"","remark":""}',
 AI_push_open_2_uv BIGINT comment '{"chs_name":"AI_push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 AI_push_open_2_pv BIGINT comment '{"chs_name":"AI_push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 auto_receive_uv BIGINT comment '{"chs_name":"除运营外push拉起设备数","description":"","etl":"","value":"","remark":""}',
 auto_receive_pv BIGINT comment '{"chs_name":"除运营外push拉起人次","description":"","etl":"","value":"","remark":""}',
 auto_push_open_uv BIGINT comment '{"chs_name":"除运营外push拉起设备数","description":"","etl":"","value":"","remark":""}',
 auto_push_open_pv BIGINT comment '{"chs_name":"除运营外push拉起人次","description":"","etl":"","value":"","remark":""}',
 auto_push_open_2_uv BIGINT comment '{"chs_name":"除运营外push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 auto_push_open_2_pv BIGINT comment '{"chs_name":"除运营外push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 location_receive_uv BIGINT comment '{"chs_name":"地狱push拉起设备数","description":"","etl":"","value":"","remark":""}',
 location_receive_pv BIGINT comment '{"chs_name":"地狱push拉起人次","description":"","etl":"","value":"","remark":""}',
 location_push_open_uv BIGINT comment '{"chs_name":"地狱push拉起设备数","description":"","etl":"","value":"","remark":""}',
 location_push_open_pv BIGINT comment '{"chs_name":"地狱push拉起人次","description":"","etl":"","value":"","remark":""}',
 location_push_open_2_uv BIGINT comment '{"chs_name":"地狱push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 location_push_open_2_pv BIGINT comment '{"chs_name":"地狱push拉起有2跳人次","description":"","etl":"","value":"","remark":""}',
 qa_receive_uv BIGINT comment '{"chs_name":"邀请问答push拉起设备数","description":"","etl":"","value":"","remark":""}',
 qa_receive_pv BIGINT comment '{"chs_name":"邀请问答push拉起人次","description":"","etl":"","value":"","remark":""}',
 qa_push_open_uv BIGINT comment '{"chs_name":"邀请问答push拉起设备数","description":"","etl":"","value":"","remark":""}',
 qa_push_open_pv BIGINT comment '{"chs_name":"邀请问答push拉起人次","description":"","etl":"","value":"","remark":""}',
 qa_push_open_2_uv BIGINT comment '{"chs_name":"邀请问答push拉起有2跳设备数","description":"","etl":"","value":"","remark":""}',
 qa_push_open_2_pv BIGINT comment '{"chs_name":"邀请问答push拉起有2跳人次","description":"","etl":"","value":"","remark":""}'
)comment 'push日报'
PARTITIONED BY (PARTITION_DAY STRING comment '分区日期')
ROW FORMAT DELIMITED
FIELDS TERMINATED BY '\t'
COLLECTION ITEMS TERMINATED BY '\002'
MAP KEYS TERMINATED BY '\003'
LINES TERMINATED BY '\n'
STORED AS TEXTFILE;